unit widgetfrm;

interface

uses
  {$IFNDEF FPC}Windows, {$ELSE}LResources, {$ENDIF} SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, dx_vgcore, dx_scene, dx_vglayer, dx_ani;

type
  TfrmWidget = class(TForm)
    dxScene1: TdxScene;
    Root1: TdxVisualObject;
    WidgetLayout: TdxGUIObjectLayer;
    Root2: TvxLayout;
    Front: TvxRectangle;
    Image1: TvxImage;
    Text1: TvxText;
    HudButton1: TvxHudButton;
    AniIndicator1: TvxAniIndicator;
    Back: TvxRectangle;
    Label1: TvxLabel;
    Label2: TvxLabel;
    Label3: TvxLabel;
    HudTextBox1: TvxHudTextBox;
    Label4: TvxLabel;
    HudButton2: TvxHudButton;
    HudButton3: TvxHudButton;
    GlowEffect1: TvxGlowEffect;
    GlowEffect2: TvxGlowEffect;
    FloatAnimation1: TdxFloatAnimation;
    CloseButton1: TvxCloseButton;
    procedure HudButton1Click(Sender: TObject);
    procedure HudButton2Click(Sender: TObject);
    procedure HudButton3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmWidget: TfrmWidget;

implementation

{$R *.dfm}

procedure TfrmWidget.HudButton1Click(Sender: TObject);
begin
  { rotate }
  WidgetLayout.AnimateFloat('Position.Z', 300, 0.3);
  WidgetLayout.AnimateFloatWait('RotateAngle.Y', 90, 0.3);
  { flip }
  Back.Visible := true;
  Front.Visible := false;
  // change
  WidgetLayout.RotateAngle.Y := 270;

  Height := Height + 50;
  Width := Width - 100;
  // need offet because back width <
  Left := Left + 50;
  { restore }
  WidgetLayout.AnimateFloat('Position.Z', 0, 0.3);
  WidgetLayout.AnimateFloat('RotateAngle.Y', 360, 0.3);
end;

procedure TfrmWidget.HudButton2Click(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TfrmWidget.HudButton3Click(Sender: TObject);
begin
  { rotate }
  WidgetLayout.AnimateFloat('Position.Z', 300, 0.3);
  WidgetLayout.AnimateFloatWait('RotateAngle.Y', -90, 0.3);
  { flip }
  Back.Visible := false;
  Front.Visible := true;
  // change
  WidgetLayout.RotateAngle.Y := 90;
  Height := Height - 50;
  Width := Width + 100;
  // need offet because front width >
  Left := Left - 50;
  { restore }
  WidgetLayout.AnimateFloat('Position.Z', 0, 0.3);
  WidgetLayout.AnimateFloat('RotateAngle.Y', 0, 0.3);
end;

end.
